diff --git a/src/nsterm.m b/src/nsterm.m
index 81d36be..a01fb93 100644
--- a/src/nsterm.m
+++ b/src/nsterm.m
@@ -1109,6 +2194,16 @@ static NSRect constrain_frame_rect(NSRect frameRect, bool isFullscreen)
    external (RIF) call; whole frame, called before update_window_begin
    -------------------------------------------------------------------------- */
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = f;
+
+/* *************************************************************************** */
+
+
 #ifdef NS_IMPL_COCOA
   EmacsView *view = FRAME_NS_VIEW (f);
 
@@ -1209,6 +2304,16 @@ static NSRect constrain_frame_rect(NSRect frameRect, bool isFullscreen)
 
 /*   if (f == MOUSE_HL_INFO (f)->mouse_face_mouse_frame) */
   MOUSE_HL_INFO (f)->mouse_face_defer = 0;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  f->mc_updating_frame = NULL;
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -4803,6 +5908,17 @@ in certain situations (rapid incoming events).
       bar = [[EmacsScroller alloc] initFrame: r window: win];
       wset_vertical_scroll_bar (window, make_mint_ptr (bar));
       update_p = YES;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+      /* This is only for debugging purposes. */
+      [bar mc_set_rectangle: r];
+
+/* *************************************************************************** */
+
+
     }
   else
     {
@@ -4810,12 +5926,30 @@ in certain situations (rapid incoming events).
       bar = XNS_SCROLL_BAR (window->vertical_scroll_bar);
       oldRect = [bar frame];
       r.size.width = oldRect.size.width;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
       if (FRAME_LIVE_P (f) && !NSEqualRects (oldRect, r))
         {
+          /* The main window has probably been resized.  Graciously delete the
+          old scroll bar without repainting its rectangle; and, create a new
+          scroll bar elsewhere.*/
           if (oldRect.origin.x != r.origin.x)
+            {
               ns_clear_frame_area (f, left, top, width, height);
+              [bar mc_judge];
+              bar = [[EmacsScroller alloc] initFrame: r window: win];
+              wset_vertical_scroll_bar (window, make_mint_ptr (bar));
+            }
+            else
           [bar setFrame: r];
         }
+
+/* *************************************************************************** */
+
+
     }
 
   if (update_p)
@@ -4975,9 +6109,57 @@ in certain situations (rapid incoming events).
     {
       view = [subviews objectAtIndex: i];
       if (![view isKindOfClass: [EmacsScroller class]]) continue;
-      if ([view judge])
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* `XSETWINDOW' will sometimes cause Emacs to crash when running under gdb even
+  though (w != NULL).  Therefore, we cannot reliably use `WINDOW_LIVE_P'. */
+  struct window *w = [view mc_get_window];
+  if (w != NULL
+      && NILP (w->contents))
+    {
+      BOOL debug_p = false;
+      if (debug_p
+          /* `window_box' calls `window_box_height', which will cause Emacs to
+          crash if FRAMEP (w->frame) is not satisfied. */
+          && FRAMEP (w->frame))
+        {
+          NSRect r0 = [view mc_get_rectangle];
+          int x0 = NSMinX (r0);
+          int y0 = NSMinY (r0);
+          int wd0 = NSWidth (r0);
+          int h0 = NSHeight (r0);
+          int window_y, window_height;
+          window_box (w, ANY_AREA, 0, &window_y, 0, &window_height);
+          int top = window_y;
+          int height = window_height;
+          int width = WINDOW_CONFIG_SCROLL_BAR_COLS (w) * FRAME_COLUMN_WIDTH (f);
+          int left = WINDOW_SCROLL_BAR_AREA_X (w);
+          NSRect r1 = NSMakeRect (left, top, width, height);
+          /* The parent view is flipped, so we need to flip y value. */
+          EmacsView *frame_view = FRAME_NS_VIEW (f);
+          NSRect v = [frame_view frame];
+          r1.origin.y = (v.size.height - r1.size.height - r1.origin.y);
+          int x1 = NSMinX (r1);
+          int y1 = NSMinY (r1);
+          int wd1 = NSWidth (r1);
+          int h1 = NSHeight (r1);
+          fprintf (stderr, "%s -- DEAD:\n\
+          x0/x1 (%d/%d) | y0/y1 (%d/%d) | wd0/wd1 (%d/%d) | h0/h1 (%d/%d)\n",
+          mc_window (w), x0, x1, y0, y1, wd0, wd1, h0, h1);
+        }
+      if ([view mc_judge])
         removed = YES;
     }
+    else if ([view judge])
+      removed = YES;
+
+/* *************************************************************************** */
+
+
+    }
 
   if (removed)
     [eview updateFrameSize: NO];
@@ -5106,6 +6288,21 @@ static Lisp_Object ns_string_to_lispmod (const char *s)
 extern frame_parm_handler ns_frame_parm_handlers[];
 static struct redisplay_interface ns_redisplay_interface =
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+/* `redisplay_interface' in `nsterm.m` must be in the exact same order as the
+`redisplay_interface' in `dispextern.h`! */
+
+  mc_x_write_glyphs,
+  mc_ns_draw_window_cursor,
+  mc_ns_draw_glyph_string,
+
+/* *************************************************************************** */
+
+
   ns_frame_parm_handlers,
   x_produce_glyphs,
   x_write_glyphs,
@@ -8721,6 +9918,49 @@ - (BOOL)canBecomeMainWindow
 
 @implementation EmacsScroller
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+- (void)mc_set_rectangle: (NSRect)rect
+{
+  mc_rectangle = rect;
+}
+
+- (NSRect)mc_get_rectangle
+{
+  return mc_rectangle;
+}
+
+- (struct window *)mc_get_window
+{
+  return window;
+}
+
+- (bool)mc_judge
+{
+  NSTRACE ("[EmacsScroller mc_judge]");
+  bool ret = condemned;
+  block_input ();
+  if (condemned)
+    {
+      /* ensure other scrollbar updates after deletion */
+      EmacsView *view = (EmacsView *)FRAME_NS_VIEW (frame);
+      if (view != nil)
+        view->scrollbarsNeedingUpdate++;
+    }
+  if (window)
+    wset_vertical_scroll_bar (window, Qnil);
+  window = 0;
+  [self removeFromSuperviewWithoutNeedingDisplay];
+  [self release];
+  unblock_input ();
+  return ret;
+}
+
+/* *************************************************************************** */
+
+
 /* for repeat button push */
 #define SCROLL_BAR_FIRST_DELAY 0.5
 #define SCROLL_BAR_CONTINUOUS_DELAY (1.0 / 15)
diff --git a/src/pdumper.c b/src/pdumper.c
index cb2915c..36d8bfe 100644
--- a/src/pdumper.c
+++ b/src/pdumper.c
@@ -2770,7 +2770,7 @@ dump_hash_table (struct dump_context *ctx,
 static dump_off
 dump_buffer (struct dump_context *ctx, const struct buffer *in_buffer)
 {
-#if CHECK_STRUCTS && !defined HASH_buffer_E34A11C6B9
+#if CHECK_STRUCTS && !defined HASH_buffer_A9CF81FED4
 # error "buffer changed. See CHECK_STRUCTS comment."
 #endif
   struct buffer munged_buffer = *in_buffer;
